/*
 * Copyright (c) 2015 Tricoire Sebastien 3dsman@free.fr
 *
 * This software is provided 'as-is', without any express or implied
 * warranty.  In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 * 1. The origin of this software must not be misrepresented; you must not
 * claim that you wrote the original software. If you use this software
 * in a product, an acknowledgment in the product documentation would be
 * appreciated but is not required.
 * 2. Altered source versions must be plainly marked as such, and must not be
 * misrepresented as being the original software.
 * 3. This notice may not be removed or altered from any source distribution.
 *
 */

#pragma once

#include "OE_curve.h"
#include "OE_subcurve.h"
#include <stdint.h>
#include <list>

namespace Pakal { class Archive; }

class OE_joincurve : public OE_curve
{
	public:
		/** Default constructor */
		OE_joincurve();
		OE_joincurve(OE_subcurve* curve1, OE_subcurve* curve2);
		/** Default destructor */
		virtual ~OE_joincurve();

		void persist(Pakal::Archive* archive);

		void addCurve(OE_subcurve* curve, int pos=-1);
		void removeLastCurve();
		void removeCurve(OE_subcurve* curve);
		OE_subcurve* getCurve( int index);

		/** \brief check if the curve is valid. */
		bool check();

		 /** \brief refresh the pts array. */
		virtual void refresh(float dpi, bool force=false);

		void delDependency(OE_base * object);

		virtual void refreshDependency();

		std::list<OE_subcurve*> curves;
};

